open Gobject
open Data

open GtkWebkitTypes

let may_cons = Property.may_cons
let may_cons_opt = Property.may_cons_opt

module WebResource = struct
  let cast w : webresource obj = try_cast w "WebkitWebResource"
  module P = struct
    let uri : ([>`webresource],_) property = {name="uri"; conv=string}
    let mime_type : ([>`webresource],_) property =
      {name="mime-type"; conv=string}
    let encoding : ([>`webresource],_) property =
      {name="encoding"; conv=string}
    let frame_name : ([>`webresource],_) property =
      {name="frame-name"; conv=string}
  end
  let create ?uri pl : webresource obj =
    let pl = (may_cons P.uri uri pl) in
    Gobject.unsafe_create "WebkitWebResource" pl
end

