open Gobject
open Data
open GtkWebkitTypes
module WebView = struct
  include GtkWebViewProps.WebView
  external create : unit -> webview Gtk.obj = "ml_webkit_web_view_new"
  external set_maintains_back_forward_list : webview Gtk.obj -> bool -> unit = "ml_webkit_web_view_set_maintains_back_forward_list"
  external get_back_forward_list : webview Gtk.obj -> webbackforwardlist Gtk.obj = "ml_webkit_web_view_get_back_forward_list"
  external go_to_back_forward_item : webview Gtk.obj -> webhistoryitem Gtk.obj -> bool = "ml_webkit_web_view_go_to_back_forward_item"
  external can_go_back : webview Gtk.obj -> bool = "ml_webkit_web_view_can_go_back"
  external can_go_back_or_forward : webview Gtk.obj -> int -> bool = "ml_webkit_web_view_can_go_back_or_forward"
  external can_go_forward : webview Gtk.obj -> bool = "ml_webkit_web_view_can_go_forward"
  external go_back : webview Gtk.obj -> unit = "ml_webkit_web_view_go_back"
  external go_back_or_forward : webview Gtk.obj -> int -> unit = "ml_webkit_web_view_go_back_or_forward"
  external go_forward : webview Gtk.obj -> unit = "ml_webkit_web_view_go_forward"
  external stop_loading : webview Gtk.obj -> unit = "ml_webkit_web_view_stop_loading"
  external load : webview Gtk.obj -> string -> unit = "ml_webkit_web_view_open"
  external reload : webview Gtk.obj -> unit = "ml_webkit_web_view_reload"
  external reload_bypass_cache : webview Gtk.obj -> unit = "ml_webkit_web_view_reload_bypass_cache"
  external load_uri : webview Gtk.obj -> string -> unit = "ml_webkit_web_view_load_uri"
  external load_string : webview Gtk.obj -> string -> string -> string -> string -> unit = "ml_webkit_web_view_load_string"
  external load_html_string : webview Gtk.obj -> string -> string -> unit = "ml_webkit_web_view_load_html_string"
  external load_request : webview Gtk.obj -> networkrequest Gtk.obj -> unit = "ml_webkit_web_view_load_request"
  external search_text : webview Gtk.obj -> string -> bool -> bool -> bool -> bool = "ml_webkit_web_view_search_text"
  external mark_text_matches : webview Gtk.obj -> string -> bool -> Int32.t -> Int32.t = "ml_webkit_web_view_mark_text_matches"
  external set_highlight_text_matches : webview Gtk.obj -> bool -> unit = "ml_webkit_web_view_set_highlight_text_matches"
  external unmark_text_matches : webview Gtk.obj -> unit = "ml_webkit_web_view_unmark_text_matches"
  external get_main_frame : webview Gtk.obj -> webframe Gtk.obj = "ml_webkit_web_view_get_main_frame"
  external get_focused_frame : webview Gtk.obj -> webframe Gtk.obj = "ml_webkit_web_view_get_focused_frame"
  external execute_script : webview Gtk.obj -> string -> unit = "ml_webkit_web_view_execute_script"
  external can_cut_clipboard : webview Gtk.obj -> bool = "ml_webkit_web_view_can_cut_clipboard"
  external can_copy_clipboard : webview Gtk.obj -> bool = "ml_webkit_web_view_can_copy_clipboard"
  external can_paste_clipboard : webview Gtk.obj -> bool = "ml_webkit_web_view_can_paste_clipboard"
  external cut_clipboard : webview Gtk.obj -> unit = "ml_webkit_web_view_cut_clipboard"
  external copy_clipboard : webview Gtk.obj -> unit = "ml_webkit_web_view_copy_clipboard"
  external paste_clipboard : webview Gtk.obj -> unit = "ml_webkit_web_view_paste_clipboard"
  external delete_selection : webview Gtk.obj -> unit = "ml_webkit_web_view_delete_selection"
  external has_selection : webview Gtk.obj -> bool = "ml_webkit_web_view_has_selection"
  external select_all : webview Gtk.obj -> unit = "ml_webkit_web_view_select_all"
  external get_inspector : webview Gtk.obj -> webinspector Gtk.obj = "ml_webkit_web_view_get_inspector"
  external can_show_mime_type : webview Gtk.obj -> string -> bool = "ml_webkit_web_view_can_show_mime_type"
  external zoom_in : webview Gtk.obj -> unit = "ml_webkit_web_view_zoom_in"
  external zoom_out : webview Gtk.obj -> unit = "ml_webkit_web_view_zoom_out"
  external move_cursor : webview Gtk.obj -> GtkEnums.movement_step -> int -> unit = "ml_webkit_web_view_move_cursor"
  external undo : webview Gtk.obj -> unit = "ml_webkit_web_view_undo"
  external can_undo : webview Gtk.obj -> bool = "ml_webkit_web_view_can_undo"
  external redo : webview Gtk.obj -> unit = "ml_webkit_web_view_redo"
  external can_redo : webview Gtk.obj -> bool = "ml_webkit_web_view_can_redo"
  external set_view_source_mode : webview Gtk.obj -> bool -> unit = "ml_webkit_web_view_set_view_source_mode"
  external get_view_source_mode : webview Gtk.obj -> bool = "ml_webkit_web_view_get_view_source_mode"
  external get_hit_test_result : webview Gtk.obj -> GdkEvent.Button.t -> hittestresult Gtk.obj = "ml_webkit_web_view_get_hit_test_result"
end